#!/bin/sh

HOSTNAME=tecumseh.net32.net
DBNAME=testdump
DBSUPERUSER=net32
DBCREATESCHEMASCRIPT=schema_function_based_constraints
#DBCREATESCHEMASCRIPT=schema_with_explicit_public

###### Drop Database.

echo "I am dropping the database . . ."
psql -h ${HOSTNAME} -p 5432 -d postgres -U ${DBSUPERUSER} -c "drop database if exists ${DBNAME}";


###### Create Database.

echo "I am creating the database . . ."
createdb -h ${HOSTNAME} -p 5432 -O net32 -U ${DBSUPERUSER} --encoding=UTF8 ${DBNAME}
 

###### Load the schema with function-based constraints and indices.

echo "I am creating the database objects . . ."
psql -h ${HOSTNAME} -p 5432 -d ${DBNAME} -U ${DBSUPERUSER} -f ${DBCREATESCHEMASCRIPT}.sql


###### Dump the schema.

echo "I am dumping the database . . ."
rm -f ${DBCREATESCHEMASCRIPT}.dmp
pg_dump -h ${HOSTNAME} -p 5432 -U ${DBSUPERUSER} -E UTF8 -O ${DBNAME} > ${DBCREATESCHEMASCRIPT}.dmp


###### Modify the search path in the dump to include public.  When I do this, the dump loads successfully.

###  sed -i "s,SELECT pg_catalog.set_config('search_path'\, ''\, false),SELECT pg_catalog.set_config('search_path'\, 'public\, pg_catalog'\, false),g" ${DBCREATESCHEMASCRIPT}.dmp

###### Load the database from the dump.

rm -f ${DBCREATESCHEMASCRIPT}.log
echo "I am dropping the database in order to load it . . ."
psql -h ${HOSTNAME} -p 5432 -d postgres -U ${DBSUPERUSER} -c "drop database if exists ${DBNAME}";
echo "I am creating the database in order to load it . . ."
createdb -h ${HOSTNAME} -p 5432 -O net32 -U ${DBSUPERUSER} --encoding=UTF8 ${DBNAME}
echo "I am loading the database from the dump . . ."
echo "*****************************************************************************************************************"
psql -h ${HOSTNAME} -p 5432 -d ${DBNAME} -U ${DBSUPERUSER} -f ${DBCREATESCHEMASCRIPT}.dmp 2>&1 | tee ${DBCREATESCHEMASCRIPT}.log
echo "*****************************************************************************************************************"

######

echo "I am finished."

